package speiger.src.builder.base;

import java.util.ArrayList;
import java.util.List;
import java.util.Set;

import speiger.src.builder.conditions.ICondition;

public class Segment
{
	ICondition condition;
	String text;
	List<ConditionedSegment> segments = new ArrayList<>();
	
	public Segment(String text, ICondition condition, List<ConditionedSegment> segments)
	{
		this.text = text;
		this.condition = condition;
		this.segments = segments;
	}
	
	public boolean build(Set<String> parsePool, StringBuilder builder, int index)
	{
		if(condition.isValid(parsePool))
		{
			builder.insert(index, text);
			for(int i = 0,offset=0,m=segments.size();i<m;i++)
			{
				offset += segments.get(i).build(parsePool, builder, index+offset);
			}
			return true;
		}
		return false;
	}
}
